function J = Mico_Jacobian(q, T_6_EE)
%#codegen
D1 = 0.2755; % Base to elbow
D2 = 0.2900; % Arm lengh
D3 = 0.1233; % Front arm lengh
D4 = 0.0741; % First wrist lengh
D5 = 0.0741; % Second wrist lengh
D6 = 0.1600; % Wrist to center of the hand

% ************************************************
aa = ((30.0*pi)/180.0);
ca = (cos(aa));
sa = (sin(aa));
c2a = (cos(2*aa));
s2a = (sin(2*aa));
d4b = (D3 + (ca-c2a/s2a*sa)*D4);
d5b = (sa/s2a*D4 + (ca-c2a/s2a*sa)*D5);
d6b = (sa/s2a*D5 + D6);

% ************************************************
% % A = DH(theta_z, d_z, a_x, alpha_x)
A1 = DH (q(1), D1, 0, 0);
A2 = DH (q(2), 0, 0, -pi/2);
A3 = DH (q(3), 0, D2, 0);
A4 = DH (q(4), d4b, 0, -pi/2);
A5 = DH (q(5), d5b, 0, 2*aa);
A6 = DH (q(6), d6b, 0, 2*aa);

% A = DH(theta_z, d_z, a_x, alpha_x)
% A1 = DH (q(1), D1, 0, -pi/2); 
% A2 = DH (q(2), 0, D2, 0);
% A3 = DH (q(3), 0, 0, -pi/2);
% A4 = DH (q(4), d4b, 0, 2*aa);
% A5 = DH (q(5), d5b, 0, 2*aa);
% A6 = DH (q(6), d6b, 0, 0);


% z0 = [0 0 1]';
% p0 = [0 0 0]';
% z1 = A1(1:3,3);
% p1 = A1(1:3,4);
% T2 = A1*A2;
% z2 = T2(1:3,3);
% p2 = T2(1:3,4);
% T3 = A1*A2*A3;
% z3 = T3(1:3,3);
% p3 = T3(1:3,4);
% T4 = A1*A2*A3*A4;
% z4 = T4(1:3,3);
% p4 = T4(1:3,4);
% T5 = A1*A2*A3*A4*A5;
% z5 = T5(1:3,3);
% p5 = T5(1:3,4);
% T6 = A1*A2*A3*A4*A5*A6;
% z6 = T6(1:3,3);
% p6 = T6(1:3,4);
% T_tool = T6 * T_6_EE(1:4,4);
% T_0_EE=T6*T_6_EE;
% p = T_tool(1:3);

%z0 = [0 0 1]';
%p0 = [0 0 0]';
z0 = A1(1:3,3);
p0 = A1(1:3,4);
T2 = A1*A2;
z1 = T2(1:3,3);
p1 = T2(1:3,4);
T3 = A1*A2*A3;
z2 = T3(1:3,3);
p2 = T3(1:3,4);
T4 = A1*A2*A3*A4;
z3 = T4(1:3,3);
p3 = T4(1:3,4);
T5 = A1*A2*A3*A4*A5;
z4 = T5(1:3,3);
p4 = T5(1:3,4);
T6 = A1*A2*A3*A4*A5*A6;
z5 = T6(1:3,3);
p5 = T6(1:3,4);
T_tool = T6 * T_6_EE(1:4,4);
T_0_EE=T6*T_6_EE;
p = T_tool(1:3);


J = [cross(z0,(p-p0)) cross(z1,(p-p1)) cross(z2,(p-p2)) cross(z3,(p-p3)) cross(z4,(p-p4)) cross(z5,(p-p5))
    z0 z1 z2 z3 z4 z5];